
#include "Utility.h"

//#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
#include <commdlg.h>
#include <Shlwapi.h>
#include <Wbemidl.h>
#include <ShObjIdl.h>
#include <shlobj.h>

#include <fstream>

std::string getExecutablePath()
{
	TCHAR path[MAX_PATH];
	GetModuleFileName(NULL, path, MAX_PATH);

	PathRemoveFileSpec(path);

	return std::string(path);
}




/*
TODO: this should be replaced with Common Item Dialog, which is a newer version from Vista and up
http://msdn.microsoft.com/en-us/library/windows/desktop/bb776913(v=vs.85).aspx

*/

//class DialogEventHandler : public IFileDialogEvents,
//                            public IFileDialogControlEvents
//{
//public:
//    // IUnknown methods
//    IFACEMETHODIMP QueryInterface(REFIID riid, void** ppv)
//    {
//        static const QITAB qit[] = {
//            QITABENT(DialogEventHandler, IFileDialogEvents),
//            QITABENT(DialogEventHandler, IFileDialogControlEvents),
//            { 0 },
//        };
//        return QISearch(this, qit, riid, ppv);
//    }
//
//    IFACEMETHODIMP_(ULONG) AddRef()
//    {
//        return InterlockedIncrement(&_cRef);
//    }
//
//    IFACEMETHODIMP_(ULONG) Release()
//    {
//        long cRef = InterlockedDecrement(&_cRef);
//        if (!cRef)
//            delete this;
//        return cRef;
//    }
//
//    // IFileDialogEvents methods
//    IFACEMETHODIMP OnFileOk(IFileDialog *) { return S_OK; };
//    IFACEMETHODIMP OnFolderChange(IFileDialog *) { return S_OK; };
//    IFACEMETHODIMP OnFolderChanging(IFileDialog *, IShellItem *) { return S_OK; };
//    IFACEMETHODIMP OnHelp(IFileDialog *) { return S_OK; };
//    IFACEMETHODIMP OnSelectionChange(IFileDialog *) { return S_OK; };
//    IFACEMETHODIMP OnShareViolation(IFileDialog *, IShellItem *, FDE_SHAREVIOLATION_RESPONSE *) { return S_OK; };
//	IFACEMETHODIMP OnTypeChange(IFileDialog *pfd) { return S_OK; };
//    IFACEMETHODIMP OnOverwrite(IFileDialog *, IShellItem *, FDE_OVERWRITE_RESPONSE *) { return S_OK; };
//
//    // IFileDialogControlEvents methods
//	IFACEMETHODIMP OnItemSelected(IFileDialogCustomize *pfdc, DWORD dwIDCtl, DWORD dwIDItem) { return S_OK; }
//    IFACEMETHODIMP OnButtonClicked(IFileDialogCustomize *, DWORD) { return S_OK; };
//    IFACEMETHODIMP OnCheckButtonToggled(IFileDialogCustomize *, DWORD, BOOL) { return S_OK; };
//    IFACEMETHODIMP OnControlActivating(IFileDialogCustomize *, DWORD) { return S_OK; };
//
//    DialogEventHandler() : _cRef(1) { };
//private:
//    ~DialogEventHandler() { };
//    long _cRef;
//};
//
//HRESULT CDialogEventHandler_CreateInstance(REFIID riid, void **ppv)
//{
//    *ppv = NULL;
//    DialogEventHandler *pDialogEventHandler = new (std::nothrow) DialogEventHandler();
//    HRESULT hr = pDialogEventHandler ? S_OK : E_OUTOFMEMORY;
//    if (SUCCEEDED(hr))
//    {
//        hr = pDialogEventHandler->QueryInterface(riid, ppv);
//        pDialogEventHandler->Release();
//    }
//    return hr;
//}
//
//const COMDLG_FILTERSPEC c_rgSaveTypes[] =
//{
//    {L"All Chip8 (*.ch8)",       L"*.ch8"},
//    {L"All Documents (*.*)",         L"*.*"}
//};

bool showFileOpenDialog(HWND hwnd, std::string& outFilename)
{
	/**
	Using any file open dialog, the older GetOpenFileName or the newer COM version, will cause an exception to be thrown around 1.3mins 
	after it has been opened. But only when a debugger is attached to the process. Very annoying though, have not found any info on the
	net on this "issue". Maybe I am doing something wrong here.

	*/
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof ofn);

	char filename[MAX_PATH];
	filename[0] = '\0';
	char initialDir[MAX_PATH];

	std::string exePath = getExecutablePath();
	strcpy_s(initialDir, getExecutablePath().c_str());
	//initialDir[exePath.size()] = '\0';

	ofn.lStructSize = sizeof OPENFILENAME;
	ofn.hwndOwner = hwnd;
	ofn.hInstance = GetModuleHandle(NULL);
	ofn.lpstrDefExt = 0;
	ofn.lpstrFile = filename;
	//ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = "All Chip8 programs\0*.ch8;*.c8;*.sc\0All files\0*.*\0\0";
	ofn.nFilterIndex = 0;
	ofn.lpstrInitialDir = initialDir;
	ofn.lpstrTitle = "Choose program\0";
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	bool result = GetOpenFileName( &ofn );
	
	//outFilename = "hello";
	if (result)
		outFilename.append(filename);
	
	return result;

	 // CoCreate the File Open Dialog object.
 //   IFileDialog *pfd = NULL;
 //   HRESULT hr = CoCreateInstance(CLSID_FileOpenDialog, 
 //                     NULL, 
 //                     CLSCTX_INPROC_SERVER, 
 //                     IID_PPV_ARGS(&pfd));
 //   if (SUCCEEDED(hr))
 //   {
 //       // Create an event handling object, and hook it up to the dialog.
 //       IFileDialogEvents *pfde = NULL;
 //       hr = CDialogEventHandler_CreateInstance(IID_PPV_ARGS(&pfde));
 //       if (SUCCEEDED(hr))
 //       {
 //           // Hook up the event handler.
 //           DWORD dwCookie;
 //           hr = pfd->Advise(pfde, &dwCookie);
 //           if (SUCCEEDED(hr))
 //           {
 //               // Set the options on the dialog.
 //               DWORD dwFlags;

 //               // Before setting, always get the options first in order 
 //               // not to override existing options.
 //               hr = pfd->GetOptions(&dwFlags);
 //               if (SUCCEEDED(hr))
 //               {
 //                   // In this case, get shell items only for file system items.
 //                   hr = pfd->SetOptions(dwFlags | FOS_FORCEFILESYSTEM);
 //                   if (SUCCEEDED(hr))
 //                   {
 //                       // Set the file types to display only. 
 //                       // Notice that this is a 1-based array.
 //                       hr = pfd->SetFileTypes(ARRAYSIZE(c_rgSaveTypes), c_rgSaveTypes);
 //                       if (SUCCEEDED(hr))
 //                       {
 //                           // Set the selected file type index to Word Docs for this example.
 //                           hr = pfd->SetFileTypeIndex(0);
 //                           if (SUCCEEDED(hr))
 //                           {
 //                               // Set the default extension to be ".doc" file.
 //                               hr = pfd->SetDefaultExtension(L"ch8");
 //                               if (SUCCEEDED(hr))
 //                               {
 //                                   // Show the dialog
 //                                   hr = pfd->Show(NULL);
 //                                   if (SUCCEEDED(hr))
 //                                   {
 //                                       // Obtain the result once the user clicks 
 //                                       // the 'Open' button.
 //                                       // The result is an IShellItem object.
 //                                       IShellItem *psiResult;
 //                                       hr = pfd->GetResult(&psiResult);
 //                                       if (SUCCEEDED(hr))
 //                                       {
 //                                           // We are just going to print out the 
 //                                           // name of the file for sample sake.
 //                                           PWSTR pszFilePath = NULL;
 //                                           hr = psiResult->GetDisplayName(SIGDN_FILESYSPATH, 
 //                                                              &pszFilePath);
 //                                           if (SUCCEEDED(hr))
 //                                           {
 //                                               /*TaskDialog(NULL,
 //                                                          NULL,
 //                                                          L"CommonFileDialogApp",
 //                                                          pszFilePath,
 //                                                          NULL,
 //                                                          TDCBF_OK_BUTTON,
 //                                                          TD_INFORMATION_ICON,
 //                                                          NULL);*/
	//											static char mbstr[MAX_PATH];
	//											wcstombs(mbstr, pszFilePath, MAX_PATH);
	//											outFilename = std::string(mbstr);
 //                                               CoTaskMemFree(pszFilePath);
 //                                           }
 //                                           psiResult->Release();
 //                                       }
 //                                   }
 //                               }
 //                           }
 //                       }
 //                   }
 //               }
 //               // Unhook the event handler.
 //               pfd->Unadvise(dwCookie);
 //           }
 //           pfde->Release();
 //       }
 //       pfd->Release();
 //   }
	//return SUCCEEDED(hr);

}

std::string readFile(const std::string& filename)
{
	std::ifstream fin(filename, std::ifstream::binary);

	fin.seekg(0, std::ios::end);
	std::streamoff filesize = fin.tellg();
	fin.seekg(0, std::ios::beg);
	//char* content = new char[filesize];
	unsigned char* memfile = new unsigned char[filesize+1];
	memset(memfile, 0, filesize);
	fin.read((char*)memfile, filesize);
	memfile[filesize] = '\0';
	std::string returnvalue((char*)memfile, (char*)memfile+filesize);
	return returnvalue;
}


template<>
std::string toStrHex(const uint8_t& value)
{
	return toStrHex(static_cast<uint32_t>(value));
}