#pragma once

#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <Windows.h>
#include <string>
#include <sstream>
#include <cstdint>

std::string getExecutablePath();
bool showFileOpenDialog(HWND hwnd, std::string& filename);
std::string readFile(const std::string& filename);

template<typename T>
std::string toStrHex(const T& value)
{
	std::ostringstream oss;
	oss.setf(std::ios::hex, std::ios::basefield);
	oss.setf(std::ios::uppercase);
	oss << value;

	return oss.str();
}

template<>
std::string toStrHex(const uint8_t& value);

template<typename T>
std::string toStr(const T& value)
{
	std::ostringstream oss;
	oss << value;

	return oss.str();
}